﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using TelegramParsingLibrary;

namespace ParsingTelegramChannel
{
    public partial class Form1 : Form
    {
        private TelegramHelper _tlHelper;
        private StringBuilder _password = new StringBuilder();
       // private readonly 

        public Form1()
        {
            InitializeComponent();

            Logger.NewError += (s, e) => addLog("<r>" + e + "</r>");
        }

        private async void Form1_Load(object sender, EventArgs e)
        {
            string id = "344729";
            string hash = "0fedb6623509243eba4e248d22b967e5";
         
            //string id = "589054";
            //string hash = "459d31f15c0cdc1633d1610112c3c399";
      
            //txtApiId.Text = Properties.Settings.Default.TelegrammApiId;
            //txtApiHash.Text = Properties.Settings.Default.TelegramApiHash;
            //txtPhoneNumber.Text = Properties.Settings.Default.TelegramPhoneNumber;
            //txtPassword.Text = Properties.Settings.Default.TelegramUserPassword;
            txtApiId.Text = id;
            txtApiHash.Text = hash;
           // txtPhoneNumber.Text = Num;
            //txtPhoneNumber.Text = txtPhoneNumber.Text;
            //txtPassword.Text = pass;
            string path = @System.IO.Directory.GetCurrentDirectory() + "\\ini.txt";
            System.IO.StreamReader sr = new System.IO.StreamReader(path, System.Text.Encoding.Default);
            string proxy = @System.IO.Directory.GetCurrentDirectory() + "\\settings.txt";
            System.IO.StreamReader pr = new System.IO.StreamReader(proxy, System.Text.Encoding.Default);
            string line;
                line = sr.ReadLine();
                    txtChannelName.Text = line;
            int cl = 0;
            string line2;
            line2 = pr.ReadLine();
            //Proxy.Text = line2;
            //    this.Opacity = 0;  //скрытая
            //   this.ShowInTaskbar = false;  //скрытая
            // подключение
            int tmpId;
            //string ProxyA = "176.107.176.168";
            //int ProxyP = 24531;
            //string ProxyN = "689097788";
            //string ProxyPas = "SjfJ3j25G2";
            string proxystr = System.Text.RegularExpressions.Regex.Match(line2, "(?<=\\[PROXY]).*?(?=;)").Value;
            string ProxyA = System.Text.RegularExpressions.Regex.Match(proxystr, "(?<=@).*(?=:)").Value;
            string ProxyPST = System.Text.RegularExpressions.Regex.Match(proxystr, "(?<=@.*:).*").Value;
            string ProxyN = System.Text.RegularExpressions.Regex.Match(proxystr, ".*?(?=:)").Value;
            string ProxyPas = System.Text.RegularExpressions.Regex.Match(proxystr, "(?<=:).*?(?=@)").Value;
            string phonestr = System.Text.RegularExpressions.Regex.Match(line2, "(?<=\\[PHONE]).*?(?=;)").Value;
            string passstr = System.Text.RegularExpressions.Regex.Match(line2, "(?<=\\[PASS]).*?(?=;)").Value;
            Proxy.Text = proxystr;
            txtPhoneNumber.Text = phonestr;
            txtPassword.Text = passstr;
            //string ProxyA = System.Text.RegularExpressions.Regex.Match(Proxy.Text, "(?<=@).*(?=:)").Value;
            //string ProxyPST = System.Text.RegularExpressions.Regex.Match(Proxy.Text, "(?<=@.*:).*").Value;
            //string ProxyN = System.Text.RegularExpressions.Regex.Match(Proxy.Text, ".*?(?=:)").Value;
            //string ProxyPas = System.Text.RegularExpressions.Regex.Match(Proxy.Text, "(?<=:).*?(?=@)").Value;
            //string ProxyA = "91.207.60.31";
            int ProxyP = Convert.ToInt32(ProxyPST);
            //int ProxyP = 8080;
            //string ProxyN = "LUKAVE";
           // string ProxyPas = "LUKAVE";
            //Proxy.Text = ProxyN + ":" + ProxyPas + "@" + ProxyA + ":" + ProxyP.ToString();
            if (int.TryParse(txtApiId.Text, out tmpId))
            {

                _tlHelper = new TelegramHelper(tmpId, txtApiHash.Text, txtPhoneNumber.Text, addLog,
                    //Properties.Settings.Default.ProxyAddress,
                    //Properties.Settings.Default.ProxyPort,
                    //Properties.Settings.Default.ProxyUserName,
                    //Properties.Settings.Default.ProxyUserPassword
                    ProxyA,
                ProxyP,
                ProxyN,
                ProxyPas
                    );

                await _tlHelper.Connect(); //автоконнект

                txtReceivedCode.Enabled = btnConfirmCode.Enabled = txtPassword.Enabled = !_tlHelper.Connected;
                btnStart.Enabled = _tlHelper.Connected;
            }
            else
            {
                addLog("<r>Wrong API Id</r>");
            }
       //     сбор
            try
            {
                if (!string.IsNullOrEmpty(txtChannelName.Text.Trim()))
                {
                    //var posts = await _tlHelper.GetNewPosts(channelName: txtChannelName.Text.Trim());
                    var posts = await _tlHelper.GetLastPosts(channelName: txtChannelName.Text.Trim(), count: 100);
                    if (posts != null && posts.Count > 0)
                    {
                        addLog($"Received new {posts.Count} posts:\n{string.Join("\n", posts.Select(p => $"{p.Item1:yyyy.MM.dd HH:mm:ss} {p.Item2} {p.Item3}"))}");
                        cl = 2;  //tесли получили посты закрываем окно
                    }
                    else
                    {
                        addLog("Received nothing");
                        cl = 1; //если не получили посты оставляем открытым окно
                    }
                }
            }
            catch (Exception ex) { Logger.WriteError(ex); }
#if TEST

#endif
            //Logger.FileName = $"{DateTime.Now:yyyyMMdd HHmmss}.txt";
            if (cl==2) this.Close();  //автозакрытие
        }

        private async void btnReceiveCode_Click(object sender, EventArgs e)
        {
            // IFormatProvider tmpId = null;
            // if (int.TryParse(txtApiId.Text, out int tmpId))
            int tmpId;
            //string ProxyA = "176.107.176.168";
            //int ProxyP = 24531;
            //string ProxyN = "689097788";
            //string ProxyPas = "SjfJ3j25G2";
            //string ProxyA = "91.207.60.31";
            //int ProxyP = 8080;
            //string ProxyN = "LUKAVE";
            //string ProxyPas = "LUKAVE";
            string ProxyA = System.Text.RegularExpressions.Regex.Match(Proxy.Text, "(?<=@).*(?=:)").Value;
            string ProxyPST = System.Text.RegularExpressions.Regex.Match(Proxy.Text, "(?<=@.*:).*").Value;
            string ProxyN = System.Text.RegularExpressions.Regex.Match(Proxy.Text, ".*?(?=:)").Value;
            string ProxyPas = System.Text.RegularExpressions.Regex.Match(Proxy.Text, "(?<=:).*?(?=@)").Value;
            //string ProxyA = "91.207.60.31";
            int ProxyP = Convert.ToInt32(ProxyPST);
            if (int.TryParse(txtApiId.Text, out tmpId))
            {
                
                _tlHelper = new TelegramHelper(tmpId, txtApiHash.Text, txtPhoneNumber.Text, addLog,
                    //Properties.Settings.Default.ProxyAddress,
                    //Properties.Settings.Default.ProxyPort,
                    //Properties.Settings.Default.ProxyUserName,
                    //Properties.Settings.Default.ProxyUserPassword
                    ProxyA,
                ProxyP,
                ProxyN,
                ProxyPas
                    );

                await _tlHelper.Connect();

                txtReceivedCode.Enabled = btnConfirmCode.Enabled = txtPassword.Enabled = !_tlHelper.Connected;
                btnStart.Enabled = _tlHelper.Connected;
            }
            else
            {
                addLog("<r>Wrong API Id</r>");
            }
        }

        private void addLog(string obj)
        {
            if (InvokeRequired)
            {
                Invoke((MethodInvoker)delegate () { addLog(obj); });
                return;
            }

            rtbExtended1.NewMessage(obj);
        }

        private async void btnConfirmCode_Click(object sender, EventArgs e)
        {
            await _tlHelper.SignInWithCode(txtReceivedCode.Text, getPassword);

            txtReceivedCode.Enabled = btnConfirmCode.Enabled = txtPassword.Enabled = !_tlHelper.Connected;
            btnStart.Enabled = _tlHelper.Connected;
        }

        private string getPassword()
        {
            return _password.ToString();
        }

        private async void btnStart_Click(object sender, EventArgs e)
        {
            try
            {
                if (!string.IsNullOrEmpty(txtChannelName.Text.Trim()))
                {
                    //var posts = await _tlHelper.GetNewPosts(channelName: txtChannelName.Text.Trim());
                    var posts = await _tlHelper.GetLastPosts(channelName: txtChannelName.Text.Trim(), count: 100);
                    if (posts != null && posts.Count > 0)
                    {
                        addLog($"Received new {posts.Count} posts:\n{string.Join("\n", posts.Select(p => $"{p.Item1:yyyy.MM.dd HH:mm:ss} {p.Item2} {p.Item3}"))}");
                    }
                    else
                    {
                        addLog("Received nothing");
                    }
                }
            }
            catch (Exception ex) { Logger.WriteError(ex); }
        }

        private void txtPassword_TextChanged(object sender, EventArgs e)
        {
            _password.Clear();
            _password.Append(txtPassword.Text);
        }

        private void label6_Click(object sender, EventArgs e)
        {

        }

        private void Proxy_TextChanged(object sender, EventArgs e)
        {

        }
    }
}
